/******************************************************************************
 GMDirectorTimerTask.cc

	BASE CLASS = public JXTimerTask

	Copyright  1999 by Glenn W. Bach.  All rights reserved.
	
 *****************************************************************************/

#include <GMDirectorTimerTask.h>

#include <jAssert.h>

const Time kGMTimerTime	= 1000; 

const JCharacter* GMDirectorTimerTask::kDirMenuTimerWentOff = "kDirMenuTimerWentOff::GMDirectorTimerTask";

/******************************************************************************
 Constructor

 *****************************************************************************/

GMDirectorTimerTask::GMDirectorTimerTask
	(
	GMDirectorManager* 	mgr, 
	GMDirectorMenu*		menu
	)
	:
	JXTimerTask(kGMTimerTime, kTrue),
	itsMgr(mgr),
	itsMenu(menu)
{
	ListenTo(this);
}

/******************************************************************************
 Destructor

 *****************************************************************************/

GMDirectorTimerTask::~GMDirectorTimerTask()
{
}

/******************************************************************************
 Receive (protected)

 ******************************************************************************/

void
GMDirectorTimerTask::Receive
	(
	JBroadcaster* 	sender, 
	const Message&	message
	)
{
	if (sender == this && message.Is(JXTimerTask::kTimerWentOff))
		{
		Broadcast(DirMenuTimerWentOff(itsMenu));
		}
}
